<?php


function elex_wfp_enable_custom_field() {
    global $post;
  ?>
<hr style="color:black;">
<span class="elex_cpp_custom_title_heading">Name Your Price</span>


<?php
    woocommerce_wp_checkbox(
        array(
        'id'        => 'elex_wfp_custom_text_field_flag',
        'desc' => __('Enable', 'elex_wfp_flexible_price_domain'),
        'desc_tip'      => __('  Enable', 'elex_wfp_flexible_price_domain'),
        'label'     => __('Product Min Price', 'elex_wfp_flexible_price_domain'),
        'description' => __('Enable this option to set a minimum price for this product. Please note, this value will override the global minimum price that you may have set.', 'elex_wfp_flexible_price_domain'),
        'value' => get_post_meta($post->ID, 'elex_wfp_custom_text_field_flag', true),
        )
    );
    woocommerce_wp_text_input(
        array(
        'id' => 'elex_wfp_custom_price_text_field',
        'label' => __( 'Set Min Price (' . get_woocommerce_currency_symbol() . ')', 'elex_wfp_flexible_price_domain'),
        'class' => 'elex-wfp-custom-field',
        
        "type" => 'number',
        'description' => __('Set the minimum price which the customer can proceed with payment.', 'elex_wfp_flexible_price_domain'),
        'custom_attributes' => array(
            'step' => '1',
            'min' =>  '00',
        ),
        'desc_tip' => true,
        'value' => get_post_meta($post->ID, 'elex_wfp_custom_price_text_field', true),
        )
    );
    woocommerce_wp_text_input( 
        array(
        'id' => 'elex_wfp_product_min_price_dynamic_label',
        'label' => __( 'Min Price Label', 'elex_wfp_flexible_price_domain'),
        'class' => 'elex-wfp-custom-field',
        
        "type" => 'text',
        'description' => __('Enter the label for the minimum price.', 'elex_wfp_flexible_price_domain'),
        'custom_attributes' => array(
            'step' => '1',
            'min' =>  '00',
        ),
        'desc_tip' => true,
        'value' => get_post_meta($post->ID, 'elex_wfp_product_min_price_dynamic_label', true),
        )
    );
    woocommerce_wp_text_input(
        array(
        'id' => 'elex_wfp_product_min_price_description',
        'label' => __( 'Min Price Description', 'elex_wfp_flexible_price_domain'),
        'class' => 'elex-wfp-custom-field',
        
        "type" => 'text',
        'description' => __('Enter Descripton for your minimum price.', 'elex_wfp_flexible_price_domain'),
        'custom_attributes' => array(
            'step' => '1',
            'min' =>  '00',
        ),
        'desc_tip' => true,
        'value' => get_post_meta($post->ID, 'elex_wfp_product_min_price_description', true),
        )
    );
    woocommerce_wp_checkbox(
        array(
        'id'        => 'elex_wfp_hide_price_regular_sale_flag',
        'desc' => __('Enable', 'elex_wfp_flexible_price_domain'),
        'desc_tip'      => __('  Enable', 'elex_wfp_flexible_price_domain'),
        'label'     => __('Hide Price', 'elex_wfp_flexible_price_domain'),
        'description' => __('Display Regualar/Sale price', 'elex_wfp_flexible_price_domain'),
        'value' => get_post_meta($post->ID, 'elex_wfp_hide_price_regular_sale_flag', true),
        )
    );
}

add_action( 'woocommerce_product_options_general_product_data', 'elex_wfp_enable_custom_field' );

function elex_wfp_save_custom_field( $post_id ) {
    $product = wc_get_product( $post_id );
    if ( $product->is_type('simple') ){
        $flag = sanitize_text_field($_POST[ 'elex_wfp_custom_text_field_flag' ]);
        if ( empty($flag ) ) {
            update_post_meta( $post_id, 'elex_wfp_custom_text_field_flag', '' );
        }
        else {
            update_post_meta( $post_id, 'elex_wfp_custom_text_field_flag', $flag );
        }
        
        $custom_price = sanitize_text_field($_POST[ 'elex_wfp_custom_price_text_field' ]);
        $custom_price = isset( $custom_price ) ? $custom_price : '';
        update_post_meta( $post_id, 'elex_wfp_custom_price_text_field',  $custom_price );

        $custom_price_label = sanitize_text_field($_POST['elex_wfp_product_min_price_dynamic_label']);
        update_post_meta( $post_id, 'elex_wfp_product_min_price_dynamic_label', $custom_price_label );

        $custom_price_desc = sanitize_text_field($_POST['elex_wfp_product_min_price_description']);
        update_post_meta( $post_id, 'elex_wfp_product_min_price_description', $custom_price_desc );
        
        $hide_price = sanitize_text_field($_POST['elex_wfp_hide_price_regular_sale_flag']);
        if ( empty($hide_price ) ) {
            update_post_meta( $post_id, 'elex_wfp_hide_price_regular_sale_flag', '' );
        }
        else {
            update_post_meta( $post_id, 'elex_wfp_hide_price_regular_sale_flag', $hide_price );
        }
        
        $product->save();
    }
    else if  ($product->is_type('variable') ) {
        $flag = get_post_meta( $post_id, 'elex_wfp_checkbox', true);
        
        $custom_price = get_post_meta( $post_id, 'elex_wfp_text_field', true);
        $custom_price_label = get_post_meta( $post_id, 'elex_wfp_label_field', true);
        $custom_price_desc = get_post_meta( $post_id, 'elex_wfp_desc_field', true);
        $product->update_meta_data('elex_wfp_custom_price_text_field', sanitize_text_field( $custom_price ));
        $product->update_meta_data('custom_text_field_flag', sanitize_text_field( $flag ));
        $product->update_meta_data('custom_text_label_field', sanitize_text_field( $custom_price_label ));
        $product->update_meta_data('custom_text_desc_field', sanitize_text_field( $custom_price_desc ));

        $product->save();
    }
}

add_action( 'woocommerce_process_product_meta', 'elex_wfp_save_custom_field' );


function elex_wfp_hide_product_price( $price ) {
    return '';
}

function elex_wfp_hide_price_script() {
    ?>
    <script>
    jQuery(document).ready(function() {
        jQuery('p.price').css("display", "none")
    });
    </script>
    <?php
}


function elex_wfp_display_custom_field() {

    global $post;
    $product = wc_get_product( $post->ID );
    if ( $product->is_type('simple') ){
    
        if ( $product->get_meta( 'elex_wfp_custom_text_field_flag') != 'yes' and  get_option('elex_cpp_settings_enable_min_product_price') == 'no' ) {
            return;
        }
        
        if ( $product->get_meta( 'elex_wfp_custom_text_field_flag') == "yes" ) {
            if ( $product->get_meta('elex_wfp_hide_price_regular_sale_flag') == "yes" ) {
                elex_wfp_hide_price_script();
            }
        }
        else if ( get_option('elex_cpp_settings_enable_min_product_price') == 'yes' )
        {
            if ( get_option( "elex_cpp_settings_enable_regular_sale_price_on_product_page" ) == 'yes' ) {
                elex_wfp_hide_price_script();
            }
        }
        $product_min_price = $product->get_meta('elex_wfp_custom_price_text_field' );
        $flag = $product->get_meta('elex_wfp_custom_text_field_flag');
        $product_min_label = $product->get_meta('elex_wfp_product_min_price_dynamic_label');
        $product_min_desc = $product->get_meta('elex_wfp_product_min_price_description');
        
        if ( $product->get_meta('elex_wfp_custom_text_field_flag') != 'yes'  ){
            $product_min_price = get_option('elex_cpp_settings_tab_min_product_price', 1);
            $product_min_desc = get_option('elex_cpp_settings_tab_min_product_price_description', 1);
            $product_min_label = get_option('elex_cpp_settings_tab_min_product_price_label', 1);
            
        }

        if ( isset($produc_min_label ) ){
            $product_min_label =__( "Enter Your Price", "elex_wfp_flexible_price_domain");
        }
        echo '<div class="wrap">';
            ob_start(); ?>

            <label class="custom-min-price1" for="custom-price-field"><?php echo $product_min_label . ' (' . get_woocommerce_currency_symbol() . ')'; ?></label>
            <input type="number" class="custom-price" value="<?php echo $product_min_price; ?>" id="custom_price_field" name="custom_price_field"  />
            <small class="description_product"> <?php echo "*" . $product_min_desc; ?> </small>
            <?php
            echo ob_get_clean();
        echo '</div>';
    }
    else if ( $product->is_type('variable') ){
    }
}


add_action( 'woocommerce_before_add_to_cart_button', 'elex_wfp_display_custom_field' );

function elex_wfp_cart_validation( $passed, $product_id, $quantity, $variation_id=null ) {
    $product = wc_get_product( $product_id );
    if ( $product->is_type('simple') ){
        $product_min_price = $product->get_meta('elex_wfp_custom_price_text_field' );
        error_log( $product_min_price );
        $flag = $product->get_meta('elex_wfp_custom_text_field_flag');
        if (get_option('elex_cpp_settings_enable_min_product_price') == 'no' and $product->get_meta( 'elex_wfp_custom_text_field_flag') != 'yes'  ) {
            
        }
        else {
            if( empty( sanitize_text_field( $_POST['custom_price_field'] ) ) ) {
                $passed = false;
                wc_add_notice( __( 'Custom Price is a required field.', 'elex_wfp_flexible_price_domain' ), 'error' );
                return $passed;
            }
            
            if ( $flag == 'yes' ) {
                if ( $product_min_price > sanitize_text_field((int)$_POST['custom_price_field'])) {
                    $passed = false;
                    wc_add_notice( __( 'Custom Price Cannot be less than '.  $product_min_price, 'elex_wfp_flexible_price_domain' ), 'error' );
                    return $passed;
                }

            }
            else  {
                if ( get_option('elex_cpp_settings_tab_min_product_price', 1) > sanitize_text_field((int)$_POST['custom_price_field'])) {
                    $passed = false;
                    wc_add_notice( __( 'Custom Price Cannot be less than '.  get_option('elex_cpp_settings_tab_min_product_price', 1), 'elex_wfp_flexible_price_domain' ), 'error' );
                    return $passed;
                }
                
            }
            update_post_meta($product_id, 'custom_price_field', sanitize_text_field($_POST['custom_price_field']));
        } 
        return $passed;
    }
    else if ( $product->is_type('variable') ){
        if (get_option('elex_cpp_settings_enable_min_product_price') == 'no'  and  get_post_meta( $variation_id, 'elex_wfp_checkbox', true ) != 'yes' ) {
            
        }
        else {
            if( empty( sanitize_text_field( $_POST['custom_price_field_variation'] ) ) ) {
                $passed = false;
                wc_add_notice( __( 'Custom Price is a required field.', 'elex_wfp_flexible_price_domain' ), 'error' );
                return $passed;
            }
            if ( get_post_meta($variation_id, 'elex_wfp_checkbox', true) == 'yes') {
                if (get_post_meta($variation_id, 'elex_wfp_text_field', true) > sanitize_text_field((int)$_POST['custom_price_field_variation'])) {
                    $passed = false;
                    wc_add_notice( __( 'Custom Price Cannot be less than '.  get_post_meta($variation_id, 'elex_wfp_text_field', true) , 'elex_wfp_flexible_price_domain' ), 'error' );
                }
            }
            else {
                if ( get_option('elex_cpp_settings_tab_min_product_price', 1) > sanitize_text_field((int)$_POST['custom_price_field_variation'])) {
                    $passed = false;
                    wc_add_notice( __( 'Custom Price Cannot be less than '.  get_option('elex_cpp_settings_tab_min_product_price', 1), 'elex_wfp_flexible_price_domain' ), 'error' );
                    return $passed;
                }
            }
            update_post_meta($product_id, 'custom_price_field', sanitize_text_field($_POST['custom_price_field_variation']));
        }
        
        return $passed;
    }
}

add_filter( 'woocommerce_add_to_cart_validation', 'elex_wfp_cart_validation', 10, 4 );

function elex_wfp_update_cart_item_data( $cart_item_data, $product_id, $variation_id ) {
    $product = wc_get_product( $product_id ); 
    if ( $product->is_type('simple') ){ 
        $flag = $product->get_meta('elex_wfp_custom_text_field_flag');
    }
    else if ( $product->is_type('variable') ) {
        $flag = get_post_meta( $variation_id, 'elex_wfp_checkbox', true );
    }

    if ( $flag != 'yes' and get_option('elex_cpp_settings_enable_min_product_price') == 'no'  ) {
        return $cart_item_data;       
    }
    $cart_item_data['custom_price_field'] = get_post_meta($product_id, 'custom_price_field', true);
    $price = $product->get_price();
    $cart_item_data['total_price'] = get_post_meta($product_id, 'custom_price_field', true);
    return $cart_item_data;
}
add_filter( 'woocommerce_add_cart_item_data', 'elex_wfp_update_cart_item_data', 10, 3 );

function elex_wfp_before_calculate_totals( $cart_obj ) {

    foreach( $cart_obj->get_cart() as $key=>$value ) {
        if ( isset( $value['total_price'] )) {
            $price = $value['total_price'];
            $value['data']->set_price( $price );
        }
    }
}
add_action( 'woocommerce_before_calculate_totals', 'elex_wfp_before_calculate_totals', 10, 3 );