<?php 

add_action( 'woocommerce_product_after_variable_attributes', 'elex_wfp_variation_settings_fields', 10, 3 );

function elex_wfp_variation_settings_fields( $loop, $variation_data, $variation ) {
    ?>
    <div class="wrap">
    <span class="elex_cpp_custom_title_heading">Name Your Price</span>

    <div class="wrap">
    <?php
    woocommerce_wp_checkbox( 
        array( 
            'id'            => 'elex_wfp_checkbox[' . $variation->ID . ']',
            'desc' => __('  Enable', 'elex_wfp_flexible_price_domain'),
            'desc_tip'      => __('  Enable', 'elex_wfp_flexible_price_domain'),
            'label'         => __('   Enable', 'elex_wfp_flexible_price_domain' ), 
            'description' => __('Enable this option to set a minimum price for this variation. Please note, this value will override the global minimum price that you may have set', 'elex_wfp_flexible_price_domain'),
            'value' => get_post_meta( $variation->ID, 'elex_wfp_checkbox', true),
            )
    );
	woocommerce_wp_text_input( 
		array( 
			'id'          => 'elex_wfp_text_field[' . $variation->ID . ']', 
			'label' => __( 'Set Min Price (' . get_woocommerce_currency_symbol() . ')', 'elex_wfp_flexible_price_domain'),
            'type' => 'number',
            'placeholder' => __( "Enter Your Price", "elex_wfp_flexible_price_domain"),
			'custom_attributes' => array(
                'step' => '1',
                'min' =>  '00',
            ),
            'desc_tip' => true,
			'description' => __('Set the minimum price of your product.', 'elex_wfp_flexible_price_domain'),
			'value'       => get_post_meta( $variation->ID, 'elex_wfp_text_field', true )
        )
    );
    woocommerce_wp_text_input(
        array(
        'id'   => 'elex_wfp_label_field[' . $variation->ID .']',
        'label' => __( 'Min Price Label', 'elex_wfp_flexible_price_domain' ),
        'type' => 'text',
        'default' => __('Product Min Price', 'elex_wfp_flexible_price_domain'),
        'css' => 'width:400px',
        'desc_tip' => true,
        'description' => __( 'Enter the label for the minimum price.', 'elex_wfp_flexible_price_domain' ),
        
        'value' => get_post_meta($variation->ID, 'elex_wfp_label_field', true),
        )
    );
    woocommerce_wp_text_input( 
        array(
        'id' => 'elex_wfp_desc_field[' . $variation->ID . ']',
        'label' => __( 'Min Price Description', 'elex_wfp_flexible_price_domain'),
        'class' => 'elex-wfp-custom-field',
        
        "type" => 'text',
        'description' => __('Enter Descripton for your minimum price.', 'elex_wfp_flexible_price_domain'),
        'custom_attributes' => array(
            'step' => '1',
            'min' =>  '00',
        ),
        'desc_tip' => true,
        'value' => get_post_meta($variation->ID, 'elex_wfp_desc_field', true),
        )
    );

    woocommerce_wp_checkbox(
        array(
        'id'        => 'elex_wfp_enable_price[' . $variation->ID . ']',
        'desc' => __('Enable', 'elex_wfp_flexible_price_domain'),
        'desc_tip'      => __('  Enable', 'elex_wfp_flexible_price_domain'),
        'label'     => __('  Hide Price', 'elex_wfp_flexible_price_domain'),
        'description' => __('Display Regualar/Sale price', 'elex_wfp_flexible_price_domain'),
        'value' => get_post_meta($variation->ID, 'elex_wfp_enable_price', true),
        )
    );
    echo '</div>';
}

add_action( 'woocommerce_save_product_variation', 'elex_wfp_save_variation_settings_fields', 10, 2 );

function elex_wfp_save_variation_settings_fields( $post_id ) {

	
	$text_field = sanitize_text_field($_POST['elex_wfp_text_field'][ $post_id ]);
	if( ! empty( $text_field ) ) {
		update_post_meta( $post_id, 'elex_wfp_text_field', esc_attr( $text_field ) );
    }
    else {
        update_post_meta( $post_id, 'elex_wfp_text_field', '' );
    }
    $checkbox =  sanitize_text_field($_POST['elex_wfp_checkbox'][ $post_id ]);
    if ( empty($checkbox ) ) {
        update_post_meta( $post_id, 'elex_wfp_checkbox', '' );
    }
    else {
        update_post_meta( $post_id, 'elex_wfp_checkbox', $checkbox );
    }
    $label_field = sanitize_text_field($_POST['elex_wfp_label_field'][$post_id]);
    if ( !empty( $label_field ) ){
        update_post_meta($post_id, 'elex_wfp_label_field', esc_attr( $label_field));
    }
    else{
        update_post_meta($post_id, 'elex_wfp_label_field', '');
    }

    $desc_field = sanitize_text_field( $_POST['elex_wfp_desc_field'][$post_id]);
    if ( !empty( $desc_field )  ){
        update_post_meta($post_id, 'elex_wfp_desc_field', esc_attr( $desc_field));
    }
    else {
        update_post_meta( $post_id, 'elex_wfp_desc_field', '' );
    }

    $enable_price_checkbox = sanitize_text_field($_POST['elex_wfp_enable_price'][$post_id]);
    if ( empty($enable_price_checkbox ) ) {
        update_post_meta( $post_id, 'elex_wfp_enable_price', '' );
    }
    else {
        update_post_meta( $post_id, 'elex_wfp_enable_price', $enable_price_checkbox );
    }
}

// Add New Variation Settings
add_filter( 'woocommerce_available_variation', 'elex_wfp_load_variation_settings_fields' );
function elex_wfp_load_variation_settings_fields( $variations ) {
        $variations['text_field'] = get_post_meta( $variations[ 'variation_id' ], 'elex_wfp_text_field', true );
        $varition['label_field'] = get_post_meta( $variations[ 'variation_id'], 'elex_wfp_label_field', true );
        $varition['desc_field'] = get_post_meta( $variations[ 'variation_id'], 'elex_wfp_desc_field', true );
        $varition['price_hide_field'] = get_post_meta( $variations[ 'variation_id'], 'elex_wfp_enable_price', true );
	return $variations;
}

function elex_wfp_ajax_load_scripts() {
	wp_enqueue_script( "ajax-test", plugin_dir_url( __FILE__ ) . '/ajax-test.js', array( 'jquery' ) );
	wp_localize_script( 'ajax-test', 'the_ajax_script', array( 'ajaxurl' => admin_url( 'admin-ajax.php' ) ) );	
}

add_action('wp_print_scripts', 'elex_wfp_ajax_load_scripts');

function elex_wfp_ajax_process_request() {
    $enable_checkbox = get_post_meta(sanitize_text_field( $_POST["var_id"]), 'elex_wfp_checkbox', true );
    

    if ( get_option('elex_cpp_settings_enable_min_product_price') == 'no' and $enable_checkbox != 'yes' ) {
        $json_response = array(
            "general_flag" => 'no',
            "value" => '',
            "label" => '',
            "desc" => '', 
            "hide_price" => get_option('elex_cpp_settings_enable_regular_sale_price_on_product_page'), "currency_symbol" => get_woocommerce_currency_symbol(),
        );
        echo json_encode($json_response);
        die();
    }
    if ( $enable_checkbox == 'yes' ) {
        $custom_field_value = get_post_meta(sanitize_text_field( $_POST["var_id"]), 'elex_wfp_text_field', true);
        $custom_field_label = get_post_meta(sanitize_text_field( $_POST["var_id"]), 'elex_wfp_label_field', true);  
        $custom_field_desc = get_post_meta(sanitize_text_field( $_POST["var_id"]), 'elex_wfp_desc_field', true);  
        $enable_price_flag = get_post_meta(sanitize_text_field( $_POST["var_id"]), 'elex_wfp_enable_price', true);
    }
    else {
        $custom_field_value = get_option('elex_cpp_settings_tab_min_product_price' );
        $custom_field_label = get_option('elex_cpp_settings_tab_min_product_price_label');  
        $custom_field_desc = get_option( 'elex_cpp_settings_tab_min_product_price_description');  
        $enable_price_flag = get_option('elex_cpp_settings_enable_regular_sale_price_on_product_page');
    
    }
    $json_response = array(
        "general_flag" => "yes",
        "value" => $custom_field_value,
        "label" => $custom_field_label,
        "desc" => $custom_field_desc, 
        "hide_price" => $enable_price_flag, "currency_symbol" => get_woocommerce_currency_symbol(),
    );
    echo json_encode($json_response);
    die();

}
add_action('wp_ajax_test_response', 'elex_wfp_ajax_process_request');
add_action('wp_ajax_nopriv_test_response', 'elex_wfp_ajax_process_request');